PingAuthorize API Reference

Create Target

POST {{apiPath}}/v2/policy-manager/targets?branch={{branchId}}

The POST /v2/policy-manager/targets operation creates a new target. The request must provide either a branch ID or a snapshot ID in the request URL to specify where the target should be created.

Use the unique ID generated upon creation to add that target to a policy.

Prerequisites

Query parameters
Query parameter Description

branch

Branch ID or name

snapshot

Snapshot ID

Request Model

For property descriptions, refer to Targets data model.

Property Type Required

name

String

Required

type

String

Optional

description

String

Optional

shared

Boolean

Optional

disabled

Boolean

Optional

targeted

Object{}

Optional

Headers

Content-Type      application/json

x-user-id      {{userId}}

Body

raw ( application/json )

{
    "type": "target",
    "name": "new-example-target",
    "description": "",
    "shared": true,
    "disabled": false,
    "targeted": {
        "action": [
            {{actionId_1}}
        ],
        "services":[
            {{servicesId_1}}
        ]
    }
}

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff '{{apiPath}}/v2/policy-manager/targets?branch={{branchId}}' \
--header 'x-user-id: {{userId}}' \
--header 'Content-Type: application/json' \
--data '{
    "type": "target",
    "name": "new-example-target",
    "description": "",
    "shared": true,
    "disabled": false,
    "targeted": {
        "action": [
            {{actionId_1}}
        ],
        "services":[
            {{servicesId_1}}
        ]
    }
}'
var options = new RestClientOptions("{{apiPath}}/v2/policy-manager/targets?branch={{branchId}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("x-user-id", "{{userId}}");
request.AddHeader("Content-Type", "application/json");
var body = @"{" + "\n" +
@"    ""type"": ""target""," + "\n" +
@"    ""name"": ""new-example-target""," + "\n" +
@"    ""description"": """"," + "\n" +
@"    ""shared"": true," + "\n" +
@"    ""disabled"": false," + "\n" +
@"    ""targeted"": {" + "\n" +
@"        ""action"": [" + "\n" +
@"            {{actionId_1}}" + "\n" +
@"        ], " + "\n" +
@"        ""services"":[" + "\n" +
@"            {{servicesId_1}}" + "\n" +
@"        ]" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v2/policy-manager/targets?branch={{branchId}}"
  method := "POST"

  payload := strings.NewReader(`{
    "type": "target",
    "name": "new-example-target",
    "description": "",
    "shared": true,
    "disabled": false,
    "targeted": {
        "action": [
            {{actionId_1}}
        ],
        "services":[
            {{servicesId_1}}
        ]
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("x-user-id", "{{userId}}")
  req.Header.Add("Content-Type", "application/json")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
POST /v2/policy-manager/targets?branch={{branchId}} HTTP/1.1
Host: {{apiPath}}
x-user-id: {{userId}}
Content-Type: application/json

{
    "type": "target",
    "name": "new-example-target",
    "description": "",
    "shared": true,
    "disabled": false,
    "targeted": {
        "action": [
            {{actionId_1}}
        ],
        "services":[
            {{servicesId_1}}
        ]
    }
}
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"type\": \"target\",\n    \"name\": \"new-example-target\",\n    \"description\": \"\",\n    \"shared\": true,\n    \"disabled\": false,\n    \"targeted\": {\n        \"action\": [\n            {{actionId_1}}\n        ], \n        \"services\":[\n            {{servicesId_1}}\n        ]\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v2/policy-manager/targets?branch={{branchId}}")
  .method("POST", body)
  .addHeader("x-user-id", "{{userId}}")
  .addHeader("Content-Type", "application/json")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{apiPath}}/v2/policy-manager/targets?branch={{branchId}}",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "x-user-id": "{{userId}}",
    "Content-Type": "application/json"
  },
  "data": "{\n    \"type\": \"target\",\n    \"name\": \"new-example-target\",\n    \"description\": \"\",\n    \"shared\": true,\n    \"disabled\": false,\n    \"targeted\": {\n        \"action\": [\n            {{actionId_1}}\n        ], \n        \"services\":[\n            {{servicesId_1}}\n        ]\n    }\n}",
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v2/policy-manager/targets?branch={{branchId}}',
  'headers': {
    'x-user-id': '{{userId}}',
    'Content-Type': 'application/json'
  },
  body: '{\n    "type": "target",\n    "name": "new-example-target",\n    "description": "",\n    "shared": true,\n    "disabled": false,\n    "targeted": {\n        "action": [\n            {{actionId_1}}\n        ], \n        "services":[\n            {{servicesId_1}}\n        ]\n    }\n}'

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests
import json

url = "{{apiPath}}/v2/policy-manager/targets?branch={{branchId}}"

payload = "{\n    \"type\": \"target\",\n    \"name\": \"new-example-target\",\n    \"description\": \"\",\n    \"shared\": true,\n    \"disabled\": false,\n    \"targeted\": {\n        \"action\": [\n            {{actionId_1}}\n        ], \n        \"services\":[\n            {{servicesId_1}}\n        ]\n    }\n}"
headers = {
  'x-user-id': '{{userId}}',
  'Content-Type': 'application/json'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v2/policy-manager/targets?branch={{branchId}}');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'x-user-id' => '{{userId}}',
  'Content-Type' => 'application/json'
));
$request->setBody('{\n    "type": "target",\n    "name": "new-example-target",\n    "description": "",\n    "shared": true,\n    "disabled": false,\n    "targeted": {\n        "action": [\n            {{actionId_1}}\n        ], \n        "services":[\n            {{servicesId_1}}\n        ]\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v2/policy-manager/targets?branch={{branchId}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["x-user-id"] = "{{userId}}"
request["Content-Type"] = "application/json"
request.body = "{\n    \"type\": \"target\",\n    \"name\": \"new-example-target\",\n    \"description\": \"\",\n    \"shared\": true,\n    \"disabled\": false,\n    \"targeted\": {\n        \"action\": [\n            {{actionId_1}}\n        ], \n        \"services\":[\n            {{servicesId_1}}\n        ]\n    }\n}"

response = http.request(request)
puts response.read_body
let parameters = "{\n    \"type\": \"target\",\n    \"name\": \"new-example-target\",\n    \"description\": \"\",\n    \"shared\": true,\n    \"disabled\": false,\n    \"targeted\": {\n        \"action\": [\n            {{actionId_1}}\n        ], \n        \"services\":[\n            {{servicesId_1}}\n        ]\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v2/policy-manager/targets?branch={{branchId}}")!,timeoutInterval: Double.infinity)
request.addValue("{{userId}}", forHTTPHeaderField: "x-user-id")
request.addValue("application/json", forHTTPHeaderField: "Content-Type")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()

Example Response

201 Created

{
    "id": "4f7d0ff8-c893-46dc-afc7-7e1971668235",
    "version": "212fbc33-0635-4853-9f73-82cae999a901",
    "type": "target",
    "name": "new-example-target",
    "description": "",
    "shared": true,
    "permissions": {
        "inherit": true,
        "rolePermissions": []
    },
    "properties": [],
    "targeted": {
        "services": [
            "25769e5c-5b33-4daf-9780-3e09b6f32207"
        ],
        "actions": [
            "b072d76e-0085-4423-99c2-4e16b74e88fa"
        ]
    }
}